# This file is responsible for configuring your application
# and its dependencies with the aid of the Config module.
#
# This configuration file is loaded before any dependency and
# is restricted to this project.

# General application configuration
import Config

config :tusker_push,
  generators: [timestamp_type: :utc_datetime]

# Configures the endpoint
config :tusker_push, TuskerPushWeb.Endpoint,
  url: [host: "localhost"],
  adapter: Bandit.PhoenixAdapter,
  render_errors: [
    formats: [json: TuskerPushWeb.ErrorJSON],
    layout: false
  ],
  pubsub_server: TuskerPush.PubSub,
  live_view: [signing_salt: "6kovrN6k"]

# Configures Elixir's Logger
config :logger, :console,
  format: "$time $metadata[$level] $message\n",
  metadata: [:request_id]

# Use Jason for JSON parsing in Phoenix
config :phoenix, :json_library, Jason

config :opentelemetry, :resource, service: %{name: "tusker_push"}

# Import environment specific config. This must remain at the bottom
# of this file so it overrides the configuration defined above.
import_config "#{config_env()}.exs"
